package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmLoanLedger;
import com.zksy.system.basicData.service.CrmLoanLedgerService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 贷款台账Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmLoanLedger")
@Api(tags = "贷款台账", description = "贷款台账desc")
public class CrmLoanLedgerController extends BaseController {

    @Autowired
    private CrmLoanLedgerService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "贷款台账搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "贷款台账分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "贷款台账查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增贷款台账
     */
    @PostMapping("/save")
    @ApiOperation(value = "贷款台账新增")
    @Log(title = "新增贷款台账", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmLoanLedger crmLoanLedger) {
        return service.save(crmLoanLedger);
    }

    /**
     * 修改贷款台账
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "贷款台账修改")
    @Log(title = "修改贷款台账", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmLoanLedger crmLoanLedger) {
        return service.updateById(crmLoanLedger);
    }

    /**
     * 导入贷款台账
     */
    @ApiOperation("贷款台账导入")
    @Log(title = "贷款台账", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmLoanLedger> crmLoanLedgerAll = service.list();
            List<CrmLoanLedger> list = ExcelUtils.readMultipartFile(file, CrmLoanLedger.class,CrmLoanLedger.class.getDeclaredFields().length - 2);
            if(crmLoanLedgerAll != null && crmLoanLedgerAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("贷款台账导出")
    @Log(title = "贷款台账", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmLoanLedger> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"贷款台账",wrapperList,CrmLoanLedger.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "贷款台账", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除贷款台账", notes = "删除贷款台账")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"融资贷款信息模板");
    }
}

